<template>
    <ion-select
        aria-label="Skupiny"
        label="Skupiny"
        placeholder="Vyberte skupiny"
        :multiple="true"
        v-model="model"
    >
        <ion-select-option
            v-for="group in groupList"
            :key="group.id"
            :value="group.id"
            >{{ group.name }}</ion-select-option
        >

        <ion-select-option disabled v-if="groupList.length < 1"
            >Žádné skupiny</ion-select-option
        >
    </ion-select>
</template>

<script setup lang="ts">
import { DeviceGroupEdge, Device_Group_Filter } from '@/gql/graphql'
import { useUserStore } from '@/stores/userStore'
import { IonSelect, IonSelectOption } from '@ionic/vue'
import { useQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { computed } from 'vue'

const userStore = useUserStore()

const model = defineModel({ required: true })

const filter = userStore.data.isAdmin
    ? Device_Group_Filter.All
    : Device_Group_Filter.My

const { result: groupListResult } = useQuery(
    gql`
        query groupListSelect($filter: DEVICE_GROUP_FILTER!) {
            deviceGroupList(first: 1000, filter: $filter) {
                edges {
                    node {
                        id
                        name
                    }
                }
            }
        }
    `,
    {
        filter,
    },
    { fetchPolicy: 'network-only' }
)

const groupList = computed(() => {
    const edgeList = groupListResult?.value?.deviceGroupList?.edges
    return edgeList ? edgeList.map((edge: DeviceGroupEdge) => edge.node) : []
})
</script>
